/* Test for list box widget
 * (w) 1996 by Eero Tamminen
 *
 * $Id: listtest.c,v 1.1.1.1 1996/04/04 00:42:44 yak Exp $
 */

#include <stdio.h>
#include <Wlib.h>
#include <Wt.h>

char string[8] = "";
widget_t *text;

void enter_callback (widget_t *w, char *txt, short cursor)
{
  printf("String: %s, cursor at: %d\n", txt, cursor);
}

void click_callback(widget_t *w, char *txt, short index)
{
  strcpy(string, txt);
  /* (re)draws the string */
  wt_setopt(text, WT_STRING_ADDRESS, string, WT_EOL);
}

int main(int argc, char *argv)
{
  long tmp;
  widget_t *top, *shell, *pane, *list;
  char *list_array[] =
  {
    "first",
    "second",
    "third",
    "fourth",
    "fifth",
    "sixth",
    "seventh",
    "eight",
    "ninth",
    "tenth",
    NULL
  };

  if (!(top   = wt_init())) return 1;
  if (!(shell = wt_create(wt_shell_class, top)))      return 2;
  if (!(pane  = wt_create(wt_pane_class, shell)))     return 3;
  if (!(text  = wt_create(wt_getstring_class, pane))) return 4;
  if (!(list  = wt_create(wt_listbox_class, pane)))   return 5;

  wt_setopt (shell, WT_ICON_STRING, "list boxer", WT_EOL);

  tmp = sizeof(string);
  wt_setopt (text,
	     WT_STRING_ADDRESS, string,
	     WT_STRING_LENGTH, &tmp,
	     WT_STRING_WIDTH, &tmp,
	     WT_ACTION_CB, enter_callback,
	     WT_EOL);

  tmp = 5;	/* how many items shown at the time */
  wt_setopt (list,
	     WT_LIST_ADDRESS, list_array,
	     WT_LIST_HEIGHT, &tmp,
	     WT_ACTION_CB, click_callback,
	     WT_EOL);

  if (wt_realize(top) < 0) return 6;
  wt_run ();
  return 0;
}
