/*
 * this file is part of "The W Toolkit".
 *
 * (W) 1996, Kay Roemer.
 *
 * $Id: wt_popup.c,v 1.1 1996/04/05 20:22:40 yak Exp $
 */
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <Wlib.h>
#include <Wt.h>

static void
getpos (widget_t *parent, int *xpos, int *ypos)
{
	short x, y;
	WWIN *pwin;

	if (parent && (pwin = wt_widget2win (parent))) {
		w_querywindowpos (pwin, 1, &x, &y);
		*xpos = x + 30;
		*ypos = y + 30;
	} else {
		w_querymousepos (WROOT, &x, &y);
		*xpos = x;
		*ypos = y;
	}
}

static void
popup_select_cb (widget_t *w, int entry, char *string)
{
	widget_t *wp;
	long i = entry;

	if (i >= 0)
		++i;

	for (wp = w; wp->parent; wp = wp->parent)
		;
	wt_setopt (wp, WT_USRVAL, &i, WT_EOL);
}

int
wt_popup (char *entries,
	void (*draw_fn) (widget_t *, int, long, long, long, long))
{
	widget_t *top, *shell, *list;
	long i;
	int x, y;

	getpos (NULL, &x, &y);

	top = wt_create (wt_top_class, NULL);
	shell = wt_create (wt_shell_class, top);

	i = ShellModePopup;
	wt_setopt (shell,
		WT_MODE, &i,
		WT_XPOS, &x,
		WT_YPOS, &y,
		WT_EOL);

	list = wt_create (wt_list_class, shell);

	wt_setopt (list,
		WT_LABEL, entries,
		WT_ACTION_CB, popup_select_cb,
		WT_DRAW_FN, draw_fn,
		WT_EOL);

	wt_realize (top);

	while (!wt_do_event ()) {
		wt_getopt (top, WT_USRVAL, &i, WT_EOL);
		if (i != 0)
			break;
	}
	wt_getopt (top, WT_USRVAL, &i, WT_EOL);
	wt_delete (top);

	return i > 0 ? i-1 : i;
}
